sampler2D implicitInput : register(s0);
float minpixel: register(C0);
float maxpixel: register(C1);
float bitDepthScale : register(C5);

float4 main(float2 uv : TEXCOORD) : COLOR
{
    float histMin = minpixel / bitDepthScale;
    float histMax = maxpixel / bitDepthScale;
	
	float difScale = histMax - histMin;
	// float offset = minpixel
	float4 color = tex2D(implicitInput, uv);

	float4 result;

    if (color.b > 0)
    {
        result.rgb = color.b;
    }
    else if (color.g > 0)
    {
        result.rgb = color.g;
    }
    else
    {
        result.rgb = color.r;
    }
	result.a = color.a;
	
	//spread the autostretch
	//result.rgb = 0.5 - ((histMid - result.r) * autostretchScale);
    //result.rgb = 1.0;
	//bound the autostretch
	//((HistogramEndRange - HistogramStartRange)/2) + HistogramStartRange;
    result.rgb = (max(result.r, histMin) - histMin) / difScale;
	return result;

}