sampler2D implicitInput : register(s0);


float4 main(float2 uv : TEXCOORD) : COLOR
{

	// float offset = minpixel
	float4 color = tex2D(implicitInput, uv);

	float4 result;
	//These if's comes from the optimization technique in Autobench
	//We are only setting one color channel of the display image of a 32 bit RGB in order
	//to save on image processing time. So we need to set the others to make it actually gray. 
	//It is the first byte (which is blue for the current format). 
	//However, if we change to a separate format that maybe only sets the Red, 
	//it would be nice to handle those cases. 
	//denoise : https://github.com/zachsaw/RenderScripts/blob/master/RenderScripts/ImageProcessingShaders/MPC-HC/Denoise.hlsl
	if (color.b > 0)
	{
		result.rgb = color.b;
	}
	else if (color.g > 0)
	{
		result.rgb = color.g;
	}
	else
	{
		result.rgb = color.r;
	}
	result.a = color.a;
	
	return result;

}