sampler2D implicitInput : register(s0);
float minpixel: register(C0);
float maxpixel: register(C1);
float bitDepth : register(C4);
float bitDepthScale : register(C5);

float4 main(float2 uv : TEXCOORD) : COLOR
{
    float mult = 16;
    float histMin = ((minpixel * mult) / 65536);
    float histMax = ((maxpixel * mult) / 65536);
	//0.0625 = 4096/65536 : 4096 * 16
	
	float difScale = histMax - histMin;
	// float offset = minpixel
	float4 color = tex2D(implicitInput, uv);

	float4 result;

	result.a = color.a;
    result.rgb = color.rgb * mult;
	//spread the autostretch
	//result.rgb = 0.5 - ((histMid - result.r) * autostretchScale);
    //result.rgb = 1.0;
	//bound the autostretch
	//((HistogramEndRange - HistogramStartRange)/2) + HistogramStartRange;
    result.rgb = ((max(result.r, histMin) - histMin) / difScale) ;
	return result;

}